%define anolis_release 2
%global glib2_version 2.69.1

%{!?with_docs: %global with_docs 1}

Name:    libsoup3
Version: 3.6.5
Release: %{anolis_release}%{dist}

Summary: Soup, an HTTP library implementation

License: LGPL-2.0-or-later
URL:     https://wiki.gnome.org/Projects/libsoup
Source0: https://download.gnome.org/sources/libsoup/3.6/libsoup-%{version}.tar.xz
# From https://gitlab.com/redhat/centos-stream/rpms/libsoup3/-/tree/c10s?ref_type=heads
Patch0: 1000-CVE-2025-4948.patch
BuildRequires: gcc
BuildRequires: gettext
BuildRequires: glib-networking
BuildRequires: gi-docgen >= 2021.1
BuildRequires: krb5-devel
BuildRequires: meson >= 0.50
BuildRequires: vala
BuildRequires: pkgconfig(glib-2.0) >= %{glib2_version}
BuildRequires: pkgconfig(gio-2.0) >= %{glib2_version}
BuildRequires: pkgconfig(gobject-introspection-1.0)
BuildRequires: pkgconfig(libbrotlidec)
BuildRequires: pkgconfig(libnghttp2)
BuildRequires: pkgconfig(libpsl)
BuildRequires: pkgconfig(sqlite3)
BuildRequires: pkgconfig(sysprof-capture-4)
BuildRequires: /usr/bin/ntlm_auth

Recommends: glib-networking >= %{glib2_version}

%description
Libsoup is an HTTP library implementation in C. It was originally part
of a SOAP (Simple Object Access Protocol) implementation called Soup, but
the SOAP and non-SOAP parts have now been split into separate packages.

libsoup uses the Glib main loop and is designed to work well with GTK
applications. This enables GNOME applications to access HTTP servers
on the network in a completely asynchronous fashion, very similar to
the Gtk+ programming model (a synchronous operation mode is also
supported for those who want it), but the SOAP parts were removed
long ago.

%package devel
Summary: Header files for the Soup library
Requires: %{name} = %{version}-%{release}

%description devel
Libsoup is an HTTP library implementation in C. This package allows
you to develop applications that use the libsoup library.

%package doc
Summary: Documentation files for %{name}
# Because web fonts from upstream are not bundled in the gi-docgen package,
# packages containing documentation generated with gi-docgen should depend on
# this metapackage to ensure the proper system fonts are present.
Recommends: gi-docgen-fonts
Requires: %{name} = %{EVR}
BuildArch: noarch

%description doc
This package contains developer documentation for %{name}.

%prep
%autosetup -p1 -n libsoup-%{version}

%build
%if %{with_docs}
%meson -Ddocs=enabled -Dtests=false -Dautobahn=disabled -Dpkcs11_tests=disabled
%else
%meson -Ddocs=disabled -Dtests=false -Dautobahn=disabled -Dpkcs11_tests=disabled
%endif
%meson_build

%install
%meson_install
install -m 644 -D tests/libsoup.supp %{buildroot}%{_datadir}/libsoup-3.0/libsoup.supp

%find_lang libsoup-3.0

%generate_compatibility_deps

%files -f libsoup-3.0.lang
%license COPYING
%dir %{abidir}
%{_libdir}/libsoup-3.0.so.0*
%{abidir}/libsoup-3.0.dump
%dir %{_libdir}/girepository-1.0
%{_libdir}/girepository-1.0/Soup-3.0.typelib

%files devel
%{_includedir}/libsoup-3.0
%{_libdir}/libsoup-3.0.so
%{_libdir}/pkgconfig/libsoup-3.0.pc
%dir %{_datadir}/libsoup-3.0
%{_datadir}/libsoup-3.0/libsoup.supp
%dir %{_datadir}/gir-1.0
%{_datadir}/gir-1.0/Soup-3.0.gir
%dir %{_datadir}/vala
%dir %{_datadir}/vala/vapi
%{_datadir}/vala/vapi/libsoup-3.0.deps
%{_datadir}/vala/vapi/libsoup-3.0.vapi

%files doc
%{_docdir}/libsoup-3.0/
%doc README NEWS AUTHORS

%changelog
* Mon Jun 23 2025 lzq11122 <lzq02303433@alibaba-inc.com> - 3.6.5-2
- add patch to fix CVE-2025-4948

* Thu May 22 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.6.5-1
- Update to 3.6.5 to fix CVE-2025-32914 CVE-2025-32906 CVE-2025-32908 
  CVE-2025-32913 CVE-2025-2784

* Wed Feb 19 2025 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.6.3-1
- Update to 3.6.3 from 3.6.1

* Mon Dec 16 2024 yangxinyu <yangxinyu@nfschina.com> - 3.6.1-1
- New version 3.6.1

* Sun Apr 30 2023 Funda Wang <fundawang@yeah.net> - 3.4.2-1
- New version 3.4.2

* Fri Apr 21 2023 Funda Wang <fundawang@yeah.net> - 3.4.1-1
- New version 3.4.1

* Tue Mar 21 2023 yuanhui <yuanhui@linux.alibaba.com> - 3.4.0-1
- Init package from upstream
